package com.aitrainer.api.model

import com.google.gson.annotations.Expose
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import org.springframework.lang.NonNull
import javax.persistence.*

@Entity
data class CustomerTrainingPlan (
    @Expose @Id  @GeneratedValue(strategy = GenerationType.IDENTITY) @get: NonNull var customerTrainingPlanId: Long = 0,
    @Expose @get: NonNull var customerId: Long = 0,
    @Expose @get: NonNull var trainingPlanId: Long = 0,
    @Expose @get: NonNull var dateAdd: String? = null,
    @Expose var active: Boolean?,
    @Expose @get: NonNull var status: String? = null,
) {
    @OneToMany(fetch = FetchType.EAGER, mappedBy = "customerTrainingPlan")
    @Fetch(value = FetchMode.SUBSELECT)
    @Expose val details: List<CustomerTrainingPlanDetails> = mutableListOf<CustomerTrainingPlanDetails>()
}