package com.aitrainer.api.model

import com.google.gson.annotations.Expose
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import org.springframework.lang.NonNull
import javax.persistence.*

@Entity
data class Description (
    @Expose @Id  @GeneratedValue(strategy = GenerationType.IDENTITY) @get: NonNull var descriptionId: Long = 0,
    @Expose @get: NonNull var name: String,
    @Expose @get: NonNull var description: String,
    @Expose @get: NonNull var version: Int? = null,
    @Expose @get: NonNull var validFrom: String? = null,
    @Expose @get: NonNull var validTo: String? = null
) {
    @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "mainDescription")
    @Fetch(value = FetchMode.SUBSELECT)
    @Expose val translations: List<DescriptionTranslation> = mutableListOf<DescriptionTranslation>().toList()

}